<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for begin StructType
 * @subpackage Structs
 */
class Begin extends AbstractStructBase
{
    /**
     * The transmission
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:transmission
     * @var \StructType\Transmission
     */
    public $transmission;
    /**
     * The product
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:product
     * @var \StructType\Product
     */
    public $product;
    /**
     * The subject
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:subject
     * @var \StructType\Subject
     */
    public $subject;
    /**
     * The contributor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:contributor
     * @var \StructType\Contributor
     */
    public $contributor;
    /**
     * The supportingResource
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:supportingResource
     * @var \StructType\SupportingResource
     */
    public $supportingResource;
    /**
     * The relatedProduct
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:relatedProduct
     * @var \StructType\RelatedProduct
     */
    public $relatedProduct;
    /**
     * The descriptiveDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:descriptiveDetail
     * @var \StructType\DescriptiveDetail
     */
    public $descriptiveDetail;
    /**
     * The supplyDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:supplyDetail
     * @var \StructType\SupplyDetail
     */
    public $supplyDetail;
    /**
     * Constructor method for begin
     * @uses Begin::setTransmission()
     * @uses Begin::setProduct()
     * @uses Begin::setSubject()
     * @uses Begin::setContributor()
     * @uses Begin::setSupportingResource()
     * @uses Begin::setRelatedProduct()
     * @uses Begin::setDescriptiveDetail()
     * @uses Begin::setSupplyDetail()
     * @param \StructType\Transmission $transmission
     * @param \StructType\Product $product
     * @param \StructType\Subject $subject
     * @param \StructType\Contributor $contributor
     * @param \StructType\SupportingResource $supportingResource
     * @param \StructType\RelatedProduct $relatedProduct
     * @param \StructType\DescriptiveDetail $descriptiveDetail
     * @param \StructType\SupplyDetail $supplyDetail
     */
    public function __construct(\StructType\Transmission $transmission = null, \StructType\Product $product = null, \StructType\Subject $subject = null, \StructType\Contributor $contributor = null, \StructType\SupportingResource $supportingResource = null, \StructType\RelatedProduct $relatedProduct = null, \StructType\DescriptiveDetail $descriptiveDetail = null, \StructType\SupplyDetail $supplyDetail = null)
    {
        $this
            ->setTransmission($transmission)
            ->setProduct($product)
            ->setSubject($subject)
            ->setContributor($contributor)
            ->setSupportingResource($supportingResource)
            ->setRelatedProduct($relatedProduct)
            ->setDescriptiveDetail($descriptiveDetail)
            ->setSupplyDetail($supplyDetail);
    }
    /**
     * Get transmission value
     * @return \StructType\Transmission|null
     */
    public function getTransmission()
    {
        return $this->transmission;
    }
    /**
     * Set transmission value
     * @param \StructType\Transmission $transmission
     * @return \StructType\Begin
     */
    public function setTransmission(\StructType\Transmission $transmission = null)
    {
        $this->transmission = $transmission;
        return $this;
    }
    /**
     * Get product value
     * @return \StructType\Product|null
     */
    public function getProduct()
    {
        return $this->product;
    }
    /**
     * Set product value
     * @param \StructType\Product $product
     * @return \StructType\Begin
     */
    public function setProduct(\StructType\Product $product = null)
    {
        $this->product = $product;
        return $this;
    }
    /**
     * Get subject value
     * @return \StructType\Subject|null
     */
    public function getSubject()
    {
        return $this->subject;
    }
    /**
     * Set subject value
     * @param \StructType\Subject $subject
     * @return \StructType\Begin
     */
    public function setSubject(\StructType\Subject $subject = null)
    {
        $this->subject = $subject;
        return $this;
    }
    /**
     * Get contributor value
     * @return \StructType\Contributor|null
     */
    public function getContributor()
    {
        return $this->contributor;
    }
    /**
     * Set contributor value
     * @param \StructType\Contributor $contributor
     * @return \StructType\Begin
     */
    public function setContributor(\StructType\Contributor $contributor = null)
    {
        $this->contributor = $contributor;
        return $this;
    }
    /**
     * Get supportingResource value
     * @return \StructType\SupportingResource|null
     */
    public function getSupportingResource()
    {
        return $this->supportingResource;
    }
    /**
     * Set supportingResource value
     * @param \StructType\SupportingResource $supportingResource
     * @return \StructType\Begin
     */
    public function setSupportingResource(\StructType\SupportingResource $supportingResource = null)
    {
        $this->supportingResource = $supportingResource;
        return $this;
    }
    /**
     * Get relatedProduct value
     * @return \StructType\RelatedProduct|null
     */
    public function getRelatedProduct()
    {
        return $this->relatedProduct;
    }
    /**
     * Set relatedProduct value
     * @param \StructType\RelatedProduct $relatedProduct
     * @return \StructType\Begin
     */
    public function setRelatedProduct(\StructType\RelatedProduct $relatedProduct = null)
    {
        $this->relatedProduct = $relatedProduct;
        return $this;
    }
    /**
     * Get descriptiveDetail value
     * @return \StructType\DescriptiveDetail|null
     */
    public function getDescriptiveDetail()
    {
        return $this->descriptiveDetail;
    }
    /**
     * Set descriptiveDetail value
     * @param \StructType\DescriptiveDetail $descriptiveDetail
     * @return \StructType\Begin
     */
    public function setDescriptiveDetail(\StructType\DescriptiveDetail $descriptiveDetail = null)
    {
        $this->descriptiveDetail = $descriptiveDetail;
        return $this;
    }
    /**
     * Get supplyDetail value
     * @return \StructType\SupplyDetail|null
     */
    public function getSupplyDetail()
    {
        return $this->supplyDetail;
    }
    /**
     * Set supplyDetail value
     * @param \StructType\SupplyDetail $supplyDetail
     * @return \StructType\Begin
     */
    public function setSupplyDetail(\StructType\SupplyDetail $supplyDetail = null)
    {
        $this->supplyDetail = $supplyDetail;
        return $this;
    }
}
