<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for futurePrice StructType
 * @subpackage Structs
 */
class FuturePrice extends AbstractStructBase
{
    /**
     * The priceType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:priceType
     * @var string
     */
    public $priceType;
    /**
     * The priceAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:priceAmount
     * @var string
     */
    public $priceAmount;
    /**
     * The taxableAmount
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:taxableAmount
     * @var string
     */
    public $taxableAmount;
    /**
     * The taxeRatePercent
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:taxeRatePercent
     * @var string
     */
    public $taxeRatePercent;
    /**
     * The taxableAmount2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:taxableAmount2
     * @var string
     */
    public $taxableAmount2;
    /**
     * The taxeRatePercent2
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:taxeRatePercent2
     * @var string
     */
    public $taxeRatePercent2;
    /**
     * The territory
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:territory
     * @var string
     */
    public $territory;
    /**
     * The priceDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - ref: hns:priceDate
     * @var string
     */
    public $priceDate;
    /**
     * Constructor method for futurePrice
     * @uses FuturePrice::setPriceType()
     * @uses FuturePrice::setPriceAmount()
     * @uses FuturePrice::setTaxableAmount()
     * @uses FuturePrice::setTaxeRatePercent()
     * @uses FuturePrice::setTaxableAmount2()
     * @uses FuturePrice::setTaxeRatePercent2()
     * @uses FuturePrice::setTerritory()
     * @uses FuturePrice::setPriceDate()
     * @param string $priceType
     * @param string $priceAmount
     * @param string $taxableAmount
     * @param string $taxeRatePercent
     * @param string $taxableAmount2
     * @param string $taxeRatePercent2
     * @param string $territory
     * @param string $priceDate
     */
    public function __construct($priceType = null, $priceAmount = null, $taxableAmount = null, $taxeRatePercent = null, $taxableAmount2 = null, $taxeRatePercent2 = null, $territory = null, $priceDate = null)
    {
        $this
            ->setPriceType($priceType)
            ->setPriceAmount($priceAmount)
            ->setTaxableAmount($taxableAmount)
            ->setTaxeRatePercent($taxeRatePercent)
            ->setTaxableAmount2($taxableAmount2)
            ->setTaxeRatePercent2($taxeRatePercent2)
            ->setTerritory($territory)
            ->setPriceDate($priceDate);
    }
    /**
     * Get priceType value
     * @return string|null
     */
    public function getPriceType()
    {
        return $this->priceType;
    }
    /**
     * Set priceType value
     * @param string $priceType
     * @return \StructType\FuturePrice
     */
    public function setPriceType($priceType = null)
    {
        // validation for constraint: string
        if (!is_null($priceType) && !is_string($priceType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priceType, true), gettype($priceType)), __LINE__);
        }
        $this->priceType = $priceType;
        return $this;
    }
    /**
     * Get priceAmount value
     * @return string|null
     */
    public function getPriceAmount()
    {
        return $this->priceAmount;
    }
    /**
     * Set priceAmount value
     * @param string $priceAmount
     * @return \StructType\FuturePrice
     */
    public function setPriceAmount($priceAmount = null)
    {
        // validation for constraint: string
        if (!is_null($priceAmount) && !is_string($priceAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priceAmount, true), gettype($priceAmount)), __LINE__);
        }
        $this->priceAmount = $priceAmount;
        return $this;
    }
    /**
     * Get taxableAmount value
     * @return string|null
     */
    public function getTaxableAmount()
    {
        return $this->taxableAmount;
    }
    /**
     * Set taxableAmount value
     * @param string $taxableAmount
     * @return \StructType\FuturePrice
     */
    public function setTaxableAmount($taxableAmount = null)
    {
        // validation for constraint: string
        if (!is_null($taxableAmount) && !is_string($taxableAmount)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxableAmount, true), gettype($taxableAmount)), __LINE__);
        }
        $this->taxableAmount = $taxableAmount;
        return $this;
    }
    /**
     * Get taxeRatePercent value
     * @return string|null
     */
    public function getTaxeRatePercent()
    {
        return $this->taxeRatePercent;
    }
    /**
     * Set taxeRatePercent value
     * @param string $taxeRatePercent
     * @return \StructType\FuturePrice
     */
    public function setTaxeRatePercent($taxeRatePercent = null)
    {
        // validation for constraint: string
        if (!is_null($taxeRatePercent) && !is_string($taxeRatePercent)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxeRatePercent, true), gettype($taxeRatePercent)), __LINE__);
        }
        $this->taxeRatePercent = $taxeRatePercent;
        return $this;
    }
    /**
     * Get taxableAmount2 value
     * @return string|null
     */
    public function getTaxableAmount2()
    {
        return $this->taxableAmount2;
    }
    /**
     * Set taxableAmount2 value
     * @param string $taxableAmount2
     * @return \StructType\FuturePrice
     */
    public function setTaxableAmount2($taxableAmount2 = null)
    {
        // validation for constraint: string
        if (!is_null($taxableAmount2) && !is_string($taxableAmount2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxableAmount2, true), gettype($taxableAmount2)), __LINE__);
        }
        $this->taxableAmount2 = $taxableAmount2;
        return $this;
    }
    /**
     * Get taxeRatePercent2 value
     * @return string|null
     */
    public function getTaxeRatePercent2()
    {
        return $this->taxeRatePercent2;
    }
    /**
     * Set taxeRatePercent2 value
     * @param string $taxeRatePercent2
     * @return \StructType\FuturePrice
     */
    public function setTaxeRatePercent2($taxeRatePercent2 = null)
    {
        // validation for constraint: string
        if (!is_null($taxeRatePercent2) && !is_string($taxeRatePercent2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($taxeRatePercent2, true), gettype($taxeRatePercent2)), __LINE__);
        }
        $this->taxeRatePercent2 = $taxeRatePercent2;
        return $this;
    }
    /**
     * Get territory value
     * @return string|null
     */
    public function getTerritory()
    {
        return $this->territory;
    }
    /**
     * Set territory value
     * @param string $territory
     * @return \StructType\FuturePrice
     */
    public function setTerritory($territory = null)
    {
        // validation for constraint: string
        if (!is_null($territory) && !is_string($territory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($territory, true), gettype($territory)), __LINE__);
        }
        $this->territory = $territory;
        return $this;
    }
    /**
     * Get priceDate value
     * @return string|null
     */
    public function getPriceDate()
    {
        return $this->priceDate;
    }
    /**
     * Set priceDate value
     * @param string $priceDate
     * @return \StructType\FuturePrice
     */
    public function setPriceDate($priceDate = null)
    {
        // validation for constraint: string
        if (!is_null($priceDate) && !is_string($priceDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($priceDate, true), gettype($priceDate)), __LINE__);
        }
        $this->priceDate = $priceDate;
        return $this;
    }
}
