<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Notices StructType
 * @subpackage Structs
 */
class Notices extends AbstractStructBase
{
    /**
     * The begin
     * Meta information extracted from the WSDL
     * - choice: begin | simple
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: hns:begin
     * @var \StructType\Begin[]
     */
    public $begin;
    /**
     * The simple
     * Meta information extracted from the WSDL
     * - choice: begin | simple
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - ref: hns:simple
     * @var \StructType\Simple[]
     */
    public $simple;
    /**
     * Constructor method for Notices
     * @uses Notices::setBegin()
     * @uses Notices::setSimple()
     * @param \StructType\Begin[] $begin
     * @param \StructType\Simple[] $simple
     */
    public function __construct(array $begin = array(), array $simple = array())
    {
        $this
            ->setBegin($begin)
            ->setSimple($simple);
    }
    /**
     * Get begin value
     * @return \StructType\Begin[]|null
     */
    public function getBegin()
    {
        return isset($this->begin) ? $this->begin : null;
    }
    /**
     * This method is responsible for validating the values passed to the setBegin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBegin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBeginForArrayConstraintsFromSetBegin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $noticesBeginItem) {
            // validation for constraint: itemType
            if (!$noticesBeginItem instanceof \StructType\Begin) {
                $invalidValues[] = is_object($noticesBeginItem) ? get_class($noticesBeginItem) : sprintf('%s(%s)', gettype($noticesBeginItem), var_export($noticesBeginItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The begin property can only contain items of type \StructType\Begin, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * This method is responsible for validating the value passed to the setBegin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBegin method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateBeginForChoiceConstraintsFromSetBegin($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'simple',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property begin can\'t be set as the property %s is already set. Only one property must be set among these properties: begin, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set begin value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @throws \InvalidArgumentException
     * @param \StructType\Begin[] $begin
     * @return \StructType\Notices
     */
    public function setBegin(array $begin = array())
    {
        // validation for constraint: array
        if ('' !== ($beginArrayErrorMessage = self::validateBeginForArrayConstraintsFromSetBegin($begin))) {
            throw new \InvalidArgumentException($beginArrayErrorMessage, __LINE__);
        }
        // validation for constraint: choice(begin, simple)
        if ('' !== ($beginChoiceErrorMessage = self::validateBeginForChoiceConstraintsFromSetBegin($begin))) {
            throw new \InvalidArgumentException($beginChoiceErrorMessage, __LINE__);
        }
        if (is_null($begin) || (is_array($begin) && empty($begin))) {
            unset($this->begin);
        } else {
            $this->begin = $begin;
        }
        return $this;
    }
    /**
     * This method is responsible for validating the value passed to the addToBegin method
     * This method is willingly generated in order to preserve the one-line inline validation within the addToBegin method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateItemForChoiceConstraintsFromAddToBegin($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'simple',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property begin can\'t be set as the property %s is already set. Only one property must be set among these properties: begin, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Add item to begin value
     * @throws \InvalidArgumentException
     * @param \StructType\Begin $item
     * @return \StructType\Notices
     */
    public function addToBegin(\StructType\Begin $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Begin) {
            throw new \InvalidArgumentException(sprintf('The begin property can only contain items of type \StructType\Begin, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: choice(begin, simple)
        if ('' !== ($itemChoiceErrorMessage = self::validateItemForChoiceConstraintsFromAddToBegin($item))) {
            throw new \InvalidArgumentException($itemChoiceErrorMessage, __LINE__);
        }
        $this->begin[] = $item;
        return $this;
    }
    /**
     * Get simple value
     * @return \StructType\Simple[]|null
     */
    public function getSimple()
    {
        return isset($this->simple) ? $this->simple : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSimple method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSimple method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSimpleForArrayConstraintsFromSetSimple(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $noticesSimpleItem) {
            // validation for constraint: itemType
            if (!$noticesSimpleItem instanceof \StructType\Simple) {
                $invalidValues[] = is_object($noticesSimpleItem) ? get_class($noticesSimpleItem) : sprintf('%s(%s)', gettype($noticesSimpleItem), var_export($noticesSimpleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The simple property can only contain items of type \StructType\Simple, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * This method is responsible for validating the value passed to the setSimple method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSimple method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSimpleForChoiceConstraintsFromSetSimple($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'begin',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property simple can\'t be set as the property %s is already set. Only one property must be set among these properties: simple, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set simple value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @throws \InvalidArgumentException
     * @param \StructType\Simple[] $simple
     * @return \StructType\Notices
     */
    public function setSimple(array $simple = array())
    {
        // validation for constraint: array
        if ('' !== ($simpleArrayErrorMessage = self::validateSimpleForArrayConstraintsFromSetSimple($simple))) {
            throw new \InvalidArgumentException($simpleArrayErrorMessage, __LINE__);
        }
        // validation for constraint: choice(begin, simple)
        if ('' !== ($simpleChoiceErrorMessage = self::validateSimpleForChoiceConstraintsFromSetSimple($simple))) {
            throw new \InvalidArgumentException($simpleChoiceErrorMessage, __LINE__);
        }
        if (is_null($simple) || (is_array($simple) && empty($simple))) {
            unset($this->simple);
        } else {
            $this->simple = $simple;
        }
        return $this;
    }
    /**
     * This method is responsible for validating the value passed to the addToSimple method
     * This method is willingly generated in order to preserve the one-line inline validation within the addToSimple method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateItemForChoiceConstraintsFromAddToSimple($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'begin',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property simple can\'t be set as the property %s is already set. Only one property must be set among these properties: simple, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Add item to simple value
     * @throws \InvalidArgumentException
     * @param \StructType\Simple $item
     * @return \StructType\Notices
     */
    public function addToSimple(\StructType\Simple $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Simple) {
            throw new \InvalidArgumentException(sprintf('The simple property can only contain items of type \StructType\Simple, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        // validation for constraint: choice(begin, simple)
        if ('' !== ($itemChoiceErrorMessage = self::validateItemForChoiceConstraintsFromAddToSimple($item))) {
            throw new \InvalidArgumentException($itemChoiceErrorMessage, __LINE__);
        }
        $this->simple[] = $item;
        return $this;
    }
}
